
#include "stdafx.h"
#include "HqxTool.h"

static WORD crc;
static void update_crc(int c)
{
	DWORD temp=crc;
	for( int i=0; i!=8; i++ )
	{
		c <<= 1;
		if( (temp<<=1) & 0x10000 )
			temp = (temp & 0xffff) ^ 0x1021;
		temp ^= (c >> 8);
		c &= 0xff;
	}
	crc = (WORD)temp;
}

//!"#$%&'()*+,-012345689@ABCDEFGHIJKLMNPQRSTUVXYZ[`abcdefhijklmpqr
static const BYTE hqx[256]={
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,0x0a,0x0b,0x0c,0xff,0xff,
	0x0d,0x0e,0x0f,0x10,0x11,0x12,0x13,0xff,0x14,0x15,0xff,0xff,0xff,0xff,0xff,0xff,

	0x16,0x17,0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,0x20,0x21,0x22,0x23,0x24,0xff,
	0x25,0x26,0x27,0x28,0x29,0x2a,0x2b,0xff,0x2c,0x2d,0x2e,0x2f,0xff,0xff,0xff,0xff,
	0x30,0x31,0x32,0x33,0x34,0x35,0x36,0xff,0x37,0x38,0x39,0x3a,0x3b,0x3c,0xff,0xff,
	0x3d,0x3e,0x3f,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,

	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,

	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, };

int CHqxTool::GetByteRaw()
{
	if( bEOF )return -1;
	int c=fgetc(fp);

	if( c==-1 )
		c=':';

	if( !bStarted && c==':' )
	{	bStarted=true;return GetByteRaw();	}
	else if( bStarted && c==':' )
	{	bEOF=true;return -1;	}
	else if( 0xff==hqx[c] )
	{	return GetByteRaw();	}

	switch( i )
	{
	case 0:
		outbuf = hqx[c]<<18;
		i=1;
		return GetByteRaw();
	case 1:
		outbuf |= hqx[c]<<12;
		i=2;
		return (outbuf>>16);
	case 2:
		outbuf |= hqx[c]<<6;
		i=3;
		return ((outbuf>>8)&0xff);
	default:
	case 3:
		outbuf |= hqx[c];
		i=0;
		return (outbuf&0xff);
	}
}

int CHqxTool::GetByte()
{
	if( repeating!=0 )
	{
		repeating--;
		update_crc( prevc );
		return prevc;
	}

	int c = GetByteRaw();
	if( c==-1 )
		return -1;
	else if( c==0x90 )
	{
		c = GetByteRaw();
		if( c==-1 )
			return -1;
		else if( c==0 )
		{
			update_crc( prevc=0x90 );
			return 0x90;
		}

		repeating = c-1;
		return GetByte();
	}

	update_crc( prevc=c );
	return c;
}

/************************************************/

bool CHqxTool::FindBeginning(int limit)
{
	int ct=0;
	char str[5000];
	while( !feof(fp) && (ct++)!=limit )
	{
		kiutil::getline( str,sizeof(str),fp );
		if( 0==strcmp(str,"(This file must be converted with BinHex 4.0)") )
			return true;
		if( 0==strcmp(str,"ĩt@C BinHex4.0 ŕϊKv܂Bj") )
			return true;
	}
	return false;
}

bool CHqxTool::ProcessHeader()
{
	int j;

	bStarted = false;
	bEOF     = false;
	repeating= 0;
	prevc    = -1;
	crc      = 0;
	outbuf   = i = 0;

	// t@C
	int fnlen = GetByte();
	if( fnlen == -1 )
		return false;
	for( j=0; j!=fnlen; j++ )
		outname[j] = GetByte();
	outname[j]=0;
	// 11bytesXLbv
	for( j=0; j!=11; j++ )
		GetByte();
	// t@CTCY
	fsize = ((DWORD)GetByte()<<24)|((DWORD)GetByte()<<16)|((DWORD)GetByte()<<8)|((DWORD)GetByte());
	// 4bytesXLbv
	for( j=0; j!=4; j++ )
		GetByte();
	// CRCvZ
	update_crc(0), update_crc(0);
	WORD r_crc=crc;
	// wb_CRC
	WORD h_crc=((WORD)GetByte()<<8)|((WORD)GetByte());

	// 
	return ( r_crc==h_crc && !bEOF );
}

void CHqxTool::DoDataFork()
{
	int c;
	while( fsize-- )
	{
		c = GetByte();
		if( c==-1 )
			break;
		fputc( c, op );
	}
}

/****************************************************/

bool CHqxTool::Check( const char* fname, unsigned long fsize )
{
	if( !(fp=fopen(fname,"rb")) )
		return false;

	bool ans = FindBeginning(500) ? ProcessHeader() : false;

	fclose( fp );
	return ans;
}

bool CHqxTool::Extract( const char* fname,const char* ddir )
{
	if( !(fp=fopen(fname,"rb")) )
		return false;

	if( !(FindBeginning(-1) ? ProcessHeader() : false) )
	{
		fclose( fp );
		return false;
	}

	if( !(op=fopen(kiutil::pathMake(outname),"wb")) )
	{
		fclose(fp);
		return false;
	}

	DoDataFork();

	fclose(op), fclose(fp);
	return true;
}
