
#include "stdafx.h"
#include "IshTool.h"

bool CIshTool::Check( const char* fname, unsigned long fsize )
{
	if( !(ish = fopen( fname,"rb" )) )
		return false;

	bool ans = FindHeader();

	fclose( ish );
	return ans;
}

bool CIshTool::Extract( const char* fname,const char* ddir )
{
	strcpy( IshName,fname );
	if( !(ish = fopen( fname,"rb" )) )
		return false;

	while( FindHeader() )
	{
		if( h_Mv==0 )
			h_VLen=h_FLen;

		FILE* out=fopen( kiutil::pathMake(*h_LFN==0?h_FName:h_LFN),"wb" );

		int l;
blockread:
		if( h_FLen>=h_VLen )
			h_FLen -= h_VLen;
		else
		{
			h_VLen=h_FLen;
			h_FLen=0;
		}

		while( l=GetBlockData() )
			for( int i=0; i!=l; i++ )
				fwrite( block[i],1,blocklen[i],out );
		if( GetNextVol() )
			goto blockread;

		fclose(out);

		if( h_Flag&1 )
			kiutil::timeSet( *h_LFN==0?h_FName:h_LFN,
					(WORD)(h_LcTime>>16),(WORD)h_LcTime );

		if( !ish )
			break;
	}


	if( ish )
		fclose( ish );
	return true;
}

/****************************************************/

bool CIshTool::GetNextVol()
{
	if( h_Mv==0 || h_FLen==0 )
		return false;

	char *cp;
	int num;
	if( (cp=(char*)strrchr(IshName,'.'))==NULL || !*(cp+1) )
		num = -1;
	else
	{
		cp++;
		num = (cp[1]-'0')*10+(cp[2]-'0');
		if( num<0 || 99<num )
			num = -1;
		if( '0'<=*cp && *cp<='9' )
			num += (*cp-'0')*100;
	}
	num++;
	cp[0]=(num<100)?'i':num/100+'0';
	cp[1]=(num/10)%10+'0';
	cp[2]=   num  %10+'0';
	cp[3]=0;

	fclose( ish );
	if( !(ish = fopen(IshName,"rb")) )
		return false;
	return FindHeader( false );
}

// ish-decoders

DWORD crc32(BYTE* dat,int len,DWORD crc);
 WORD crc16(BYTE* dat,int len,WORD crc);
int decode_jis8(BYTE* str,int len,BYTE* outbuf);
int decode_jis7(BYTE* str,int len,BYTE* outbuf);
int decode_njis(BYTE* str,int len,BYTE* outbuf);
int decode_sjis(BYTE* str,int len,BYTE* outbuf);

// PubÑf[^fR[h(Ԓlʂf[^s)
int CIshTool::GetBlockData()
{
	if( h_VLen==0 )
		return 0;

	ErrCt=0;

	char str[100];
	BYTE dat[200];
	int l;

	BYTE len;
	for( len=0; len<h_LNum-2; )
	{
		if( kiutil::getline(str,100,ish)==NULL )
			return len;
		if( strlen(str)==0 )
			continue;

		switch( h_IType )
		{
		case  8:l=decode_jis8((BYTE*)str,strlen(str),dat);break;
		case 13:l=decode_jis7((BYTE*)str,strlen(str),dat);break;
		case 14:l=decode_njis((BYTE*)str,strlen(str),dat);break;
		default:
		case 15:l=decode_sjis((BYTE*)str,strlen(str),dat);break;
		}

		if( l<=3 || len+1!=*dat )
			continue;

		blocklen[len]=l-3;
		memcpy(block[len],dat+1,l-3);
		if( ErrCt<=1 )
		{
			if( (WORD)l!=h_LLen )
				ErrCt=3;
			else if( ((dat[l-2]<<8)|(dat[l-1])) != (crc16(dat,l-2,0xffff)^0xffff) )
				ErrLine[ErrCt++]=len;
		}

		len++;
		if( h_VLen<=(DWORD)blocklen[len-1] ){blocklen[len-1]=h_VLen;h_VLen=0;return len;}
		else	h_VLen-=blocklen[len-1];
	}

	// `FbJǍ
	int ct=0;
	BYTE llen=len;
	while( kiutil::getline(str,100,ish)!=NULL )
	{
		switch( h_IType )
		{
		case  8:l=decode_jis8((BYTE*)str,strlen(str),dat);break;
		case 13:l=decode_jis7((BYTE*)str,strlen(str),dat);break;
		case 14:l=decode_njis((BYTE*)str,strlen(str),dat);break;
		default:
		case 15:l=decode_sjis((BYTE*)str,strlen(str),dat);break;
		}
		if( l<=3 || llen+1!=*dat )continue;

		ct++;
		llen+=(h_bOld)?1:2;
		if( (WORD)l<h_LLen || ((dat[l-2]<<8)|(dat[l-1])) != (crc16(dat,l-2,0xffff)^0xffff) )ErrCt=3;
		if( ct==1 )memcpy(checker,dat+1,h_LLen-3);
		else if( ct==2 ){memcpy(checker2,dat+1,h_LLen-3);break;}
	}

	// G[␳
	if( ErrCt==1 )
	{
		for( BYTE i=0; i!=h_LLen-3; i++ )
		{
			BYTE datsum=0;
			for( BYTE j=0; j!=h_LNum-2; j++ )
				datsum += block[j][i];
			block[*ErrLine][i] -= checker[i]+datsum;
		}
	}
	else if( ErrCt==2 )
		ErrCt=2;//(^^;

	return len;
}

// wb_sĂ̏擾
bool CIshTool::FindHeader(bool bfirst)
{
	char str[100],str2[100],str3[100];
	if( bfirst )*h_LFN=0;

	while( NULL!=kiutil::getline(str,100,ish) )
	{
		switch( *str )
		{
		case '<':
			if( bfirst && strncmp(str,"<<< ",4)==0 && strstr(str," aish ") && strstr(str," lines") )
			{
				char *s,*p;
				for(s=h_LFN,p=str+4; *p!=' '; *s++=*p++ );
				*s=0;
			}
			break;
		case '!':
		case '#':
			{
				if( strlen(str)<=60 )break;
				if( NULL==kiutil::getline(str2,100,ish) || NULL==kiutil::getline(str3,100,ish) )
					return false;

				char* line=str;
				if( strcmp(str,str2)!=0 )
				{
					if( strcmp(str,str3)!=0 )
					{
						if( strcmp(str2,str3)!=0 )
							break;
						else
							line=str2;
					}
				}

				BYTE dat[200];
				int l;
				if( *line=='!' )l=decode_jis7((BYTE*)line,strlen(line),dat);
				else			l=decode_jis8((BYTE*)line,strlen(line),dat);
				return ProcessHeader(dat,l,bfirst);
			}
		}
	}
	return false;
}

// f[^񁄃wb_
bool CIshTool::ProcessHeader(BYTE* dat,int l,bool bfirst)
{
	if( bfirst )
	{
		h_Mv   = dat[1];
		h_FLen = ((dat[2])|(dat[3]<<8)|(dat[4]<<16)|(dat[5]<<24));
		h_LLen = ((dat[6])|(dat[7]<<8));
		h_LNum = ((dat[8])|(dat[9]<<8));
		h_IType= dat[11];
		int i,j;
		for( i=0; i!=8 && dat[i+12]!=' '; i++ )h_FName[i]=(char)dat[i+12];h_FName[i++]='.';
		for( j=8; j!=11; j++,i++ )h_FName[i]=(char)dat[j+12];h_FName[i]='\0';
		h_bOld = (h_Mv==0)?dat[25]==0:false;
		h_Flag = dat[26];
		h_LcTime=((dat[27])|(dat[28]<<8)|(dat[29]<<16)|(dat[30]<<24));
		h_DifTm= ((dat[31])|(dat[32]<<8)|(dat[33]<<16));
		h_FCRC16=((dat[34])|(dat[35]<<8));
		h_FCRC32=((dat[36])|(dat[37]<<8)|(dat[38]<<16)|(dat[39]<<24));
		h_VLen = ((dat[40])|(dat[41]<<8)|(dat[42]<<16)|(dat[43]<<24));
		h_VCRC16=((dat[44])|(dat[45]<<8));

		if( l==63 )		h_CRC=((dat[61]<<8)|(dat[62]));
		else if( l==69 )h_CRC=((dat[67]<<8)|(dat[68]));
		else			return false;

		if( 62!=h_LNum && 68!=h_LNum && 72!=h_LNum )return false;
		if( 8!=h_IType && 13!=h_IType && 14!=h_IType && 15!=h_IType )return false;

		return h_CRC==(crc16(dat,l-2,0xffff)^0xffff);
	}

	h_Mv   = dat[1];
	h_VLen = ((dat[40])|(dat[41]<<8)|(dat[42]<<16)|(dat[43]<<24));
	WORD tmpCRC;
	if( l==63 )		tmpCRC=((dat[61]<<8)|(dat[62]));
	else if( l==69 )tmpCRC=((dat[67]<<8)|(dat[68]));
	else			return false;

	return tmpCRC==(crc16(dat,l-2,0xffff)^0xffff);
}

/*****************************************************/
static DWORD crc32(BYTE* dat,int len,DWORD crc)
{static const DWORD crc32tbl[] = {
0x00000000,  0x77073096,  0xee0e612c,  0x990951ba,
0x076dc419,  0x706af48f,  0xe963a535,  0x9e6495a3,
0x0edb8832,  0x79dcb8a4,  0xe0d5e91e,  0x97d2d988,
0x09b64c2b,  0x7eb17cbd,  0xe7b82d07,  0x90bf1d91,
0x1db71064,  0x6ab020f2,  0xf3b97148,  0x84be41de,
0x1adad47d,  0x6ddde4eb,  0xf4d4b551,  0x83d385c7,
0x136c9856,  0x646ba8c0,  0xfd62f97a,  0x8a65c9ec,
0x14015c4f,  0x63066cd9,  0xfa0f3d63,  0x8d080df5,
0x3b6e20c8,  0x4c69105e,  0xd56041e4,  0xa2677172,
0x3c03e4d1,  0x4b04d447,  0xd20d85fd,  0xa50ab56b,
0x35b5a8fa,  0x42b2986c,  0xdbbbc9d6,  0xacbcf940,
0x32d86ce3,  0x45df5c75,  0xdcd60dcf,  0xabd13d59,
0x26d930ac,  0x51de003a,  0xc8d75180,  0xbfd06116,
0x21b4f4b5,  0x56b3c423,  0xcfba9599,  0xb8bda50f,
0x2802b89e,  0x5f058808,  0xc60cd9b2,  0xb10be924,
0x2f6f7c87,  0x58684c11,  0xc1611dab,  0xb6662d3d,
0x76dc4190,  0x01db7106,  0x98d220bc,  0xefd5102a,
0x71b18589,  0x06b6b51f,  0x9fbfe4a5,  0xe8b8d433,
0x7807c9a2,  0x0f00f934,  0x9609a88e,  0xe10e9818,
0x7f6a0dbb,  0x086d3d2d,  0x91646c97,  0xe6635c01,
0x6b6b51f4,  0x1c6c6162,  0x856530d8,  0xf262004e,
0x6c0695ed,  0x1b01a57b,  0x8208f4c1,  0xf50fc457,
0x65b0d9c6,  0x12b7e950,  0x8bbeb8ea,  0xfcb9887c,
0x62dd1ddf,  0x15da2d49,  0x8cd37cf3,  0xfbd44c65,
0x4db26158,  0x3ab551ce,  0xa3bc0074,  0xd4bb30e2,
0x4adfa541,  0x3dd895d7,  0xa4d1c46d,  0xd3d6f4fb,
0x4369e96a,  0x346ed9fc,  0xad678846,  0xda60b8d0,
0x44042d73,  0x33031de5,  0xaa0a4c5f,  0xdd0d7cc9,
0x5005713c,  0x270241aa,  0xbe0b1010,  0xc90c2086,
0x5768b525,  0x206f85b3,  0xb966d409,  0xce61e49f,
0x5edef90e,  0x29d9c998,  0xb0d09822,  0xc7d7a8b4,
0x59b33d17,  0x2eb40d81,  0xb7bd5c3b,  0xc0ba6cad,
0xedb88320,  0x9abfb3b6,  0x03b6e20c,  0x74b1d29a,
0xead54739,  0x9dd277af,  0x04db2615,  0x73dc1683,
0xe3630b12,  0x94643b84,  0x0d6d6a3e,  0x7a6a5aa8,
0xe40ecf0b,  0x9309ff9d,  0x0a00ae27,  0x7d079eb1,
0xf00f9344,  0x8708a3d2,  0x1e01f268,  0x6906c2fe,
0xf762575d,  0x806567cb,  0x196c3671,  0x6e6b06e7,
0xfed41b76,  0x89d32be0,  0x10da7a5a,  0x67dd4acc,
0xf9b9df6f,  0x8ebeeff9,  0x17b7be43,  0x60b08ed5,
0xd6d6a3e8,  0xa1d1937e,  0x38d8c2c4,  0x4fdff252,
0xd1bb67f1,  0xa6bc5767,  0x3fb506dd,  0x48b2364b,
0xd80d2bda,  0xaf0a1b4c,  0x36034af6,  0x41047a60,
0xdf60efc3,  0xa867df55,  0x316e8eef,  0x4669be79,
0xcb61b38c,  0xbc66831a,  0x256fd2a0,  0x5268e236,
0xcc0c7795,  0xbb0b4703,  0x220216b9,  0x5505262f,
0xc5ba3bbe,  0xb2bd0b28,  0x2bb45a92,  0x5cb36a04,
0xc2d7ffa7,  0xb5d0cf31,  0x2cd99e8b,  0x5bdeae1d,
0x9b64c2b0,  0xec63f226,  0x756aa39c,  0x026d930a,
0x9c0906a9,  0xeb0e363f,  0x72076785,  0x05005713,
0x95bf4a82,  0xe2b87a14,  0x7bb12bae,  0x0cb61b38,
0x92d28e9b,  0xe5d5be0d,  0x7cdcefb7,  0x0bdbdf21,
0x86d3d2d4,  0xf1d4e242,  0x68ddb3f8,  0x1fda836e,
0x81be16cd,  0xf6b9265b,  0x6fb077e1,  0x18b74777,
0x88085ae6,  0xff0f6a70,  0x66063bca,  0x11010b5c,
0x8f659eff,  0xf862ae69,  0x616bffd3,  0x166ccf45,
0xa00ae278,  0xd70dd2ee,  0x4e048354,  0x3903b3c2,
0xa7672661,  0xd06016f7,  0x4969474d,  0x3e6e77db,
0xaed16a4a,  0xd9d65adc,  0x40df0b66,  0x37d83bf0,
0xa9bcae53,  0xdebb9ec5,  0x47b2cf7f,  0x30b5ffe9,
0xbdbdf21c,  0xcabac28a,  0x53b39330,  0x24b4a3a6,
0xbad03605,  0xcdd70693,  0x54de5729,  0x23d967bf,
0xb3667a2e,  0xc4614ab8,  0x5d681b02,  0x2a6f2b94,
0xb40bbe37,  0xc30c8ea1,  0x5a05df1b,  0x2d02ef8d,};
while(--len>=0)crc=crc>>8^crc32tbl[(crc&0xff)^*dat++];return crc;}
static WORD crc16(BYTE* dat,int len,WORD crc)
{static const WORD crc16tbl[] = {
0x0000, 0x1021, 0x2042, 0x3063, 0x4084, 0x50A5, 0x60C6, 0x70E7, 
0x8108, 0x9129, 0xA14A, 0xB16B, 0xC18C, 0xD1AD, 0xE1CE, 0xF1EF, 
0x1231, 0x0210, 0x3273, 0x2252, 0x52B5, 0x4294, 0x72F7, 0x62D6, 
0x9339, 0x8318, 0xB37B, 0xA35A, 0xD3BD, 0xC39C, 0xF3FF, 0xE3DE, 
0x2462, 0x3443, 0x0420, 0x1401, 0x64E6, 0x74C7, 0x44A4, 0x5485, 
0xA56A, 0xB54B, 0x8528, 0x9509, 0xE5EE, 0xF5CF, 0xC5AC, 0xD58D, 
0x3653, 0x2672, 0x1611, 0x0630, 0x76D7, 0x66F6, 0x5695, 0x46B4, 
0xB75B, 0xA77A, 0x9719, 0x8738, 0xF7DF, 0xE7FE, 0xD79D, 0xC7BC, 
0x48C4, 0x58E5, 0x6886, 0x78A7, 0x0840, 0x1861, 0x2802, 0x3823, 
0xC9CC, 0xD9ED, 0xE98E, 0xF9AF, 0x8948, 0x9969, 0xA90A, 0xB92B, 
0x5AF5, 0x4AD4, 0x7AB7, 0x6A96, 0x1A71, 0x0A50, 0x3A33, 0x2A12, 
0xDBFD, 0xCBDC, 0xFBBF, 0xEB9E, 0x9B79, 0x8B58, 0xBB3B, 0xAB1A, 
0x6CA6, 0x7C87, 0x4CE4, 0x5CC5, 0x2C22, 0x3C03, 0x0C60, 0x1C41, 
0xEDAE, 0xFD8F, 0xCDEC, 0xDDCD, 0xAD2A, 0xBD0B, 0x8D68, 0x9D49, 
0x7E97, 0x6EB6, 0x5ED5, 0x4EF4, 0x3E13, 0x2E32, 0x1E51, 0x0E70, 
0xFF9F, 0xEFBE, 0xDFDD, 0xCFFC, 0xBF1B, 0xAF3A, 0x9F59, 0x8F78, 
0x9188, 0x81A9, 0xB1CA, 0xA1EB, 0xD10C, 0xC12D, 0xF14E, 0xE16F, 
0x1080, 0x00A1, 0x30C2, 0x20E3, 0x5004, 0x4025, 0x7046, 0x6067, 
0x83B9, 0x9398, 0xA3FB, 0xB3DA, 0xC33D, 0xD31C, 0xE37F, 0xF35E, 
0x02B1, 0x1290, 0x22F3, 0x32D2, 0x4235, 0x5214, 0x6277, 0x7256, 
0xB5EA, 0xA5CB, 0x95A8, 0x8589, 0xF56E, 0xE54F, 0xD52C, 0xC50D, 
0x34E2, 0x24C3, 0x14A0, 0x0481, 0x7466, 0x6447, 0x5424, 0x4405, 
0xA7DB, 0xB7FA, 0x8799, 0x97B8, 0xE75F, 0xF77E, 0xC71D, 0xD73C, 
0x26D3, 0x36F2, 0x0691, 0x16B0, 0x6657, 0x7676, 0x4615, 0x5634, 
0xD94C, 0xC96D, 0xF90E, 0xE92F, 0x99C8, 0x89E9, 0xB98A, 0xA9AB, 
0x5844, 0x4865, 0x7806, 0x6827, 0x18C0, 0x08E1, 0x3882, 0x28A3, 
0xCB7D, 0xDB5C, 0xEB3F, 0xFB1E, 0x8BF9, 0x9BD8, 0xABBB, 0xBB9A, 
0x4A75, 0x5A54, 0x6A37, 0x7A16, 0x0AF1, 0x1AD0, 0x2AB3, 0x3A92, 
0xFD2E, 0xED0F, 0xDD6C, 0xCD4D, 0xBDAA, 0xAD8B, 0x9DE8, 0x8DC9, 
0x7C26, 0x6C07, 0x5C64, 0x4C45, 0x3CA2, 0x2C83, 0x1CE0, 0x0CC1, 
0xEF1F, 0xFF3E, 0xCF5D, 0xDF7C, 0xAF9B, 0xBFBA, 0x8FD9, 0x9FF8, 
0x6E17, 0x7E36, 0x4E55, 0x5E74, 0x2E93, 0x3EB2, 0x0ED1, 0x1EF0,};
while(--len>=0)crc=crc<<8^crc16tbl[crc>>8^*dat++];return crc;}

/*****************************************************/
static const BYTE j8table[] = {
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
0xff, 0xff, 0xff, 0x00, 0xff, 0x01, 0x02, 0x03, 0xff, 0x04, 0xff, 0x05, 0x06, 0xff, 0xff, 0x08,
0xff, 0xff, 0x09, 0xff, 0x0a, 0x0b, 0x0c, 0x0d, 0x0e, 0x0f, 0x10, 0x11, 0x12, 0x13, 0x14, 0x07,
0xff, 0x15, 0x16, 0x17, 0x18, 0x19, 0x1a, 0x1b, 0x1c, 0x1d, 0xff, 0x1e, 0x1f, 0xff, 0x20, 0x21,
0xff, 0xff, 0x22, 0xff, 0x23, 0x24, 0x25, 0x26, 0x27, 0x28, 0x29, 0x2a, 0x2b, 0x2c, 0x2d, 0xff,
0xff, 0x2e, 0x2f, 0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38, 0x39, 0x3a, 0x3b, 0xff,
0x3c, 0x3d, 0x3e, 0x3f, 0x40, 0x41, 0x42, 0xff, 0x43, 0x44, 0x45, 0xff, 0x46, 0xff, 0xff, 0xff,
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
0xff, 0x47, 0x48, 0x49, 0x4a, 0x4b, 0x4c, 0x4d, 0x4e, 0x4f, 0x50, 0x51, 0x52, 0xff, 0x53, 0x54,
0x55, 0x56, 0x57, 0xff, 0x58, 0x59, 0x5a, 0x5b, 0x5c, 0x5d, 0x5e, 0x5f, 0x60, 0x61, 0x62, 0xff,
0x63, 0x64, 0x65, 0x66, 0x67, 0x68, 0x69, 0x6a, 0x6b, 0x6c, 0x6d, 0x6e, 0x6f, 0xff, 0x70, 0x71,
0x72, 0x73, 0x74, 0xff, 0x75, 0x76, 0x77, 0x78, 0x79, 0x7a, 0x7b, 0x7c, 0x7d, 0x7e, 0x7f, 0xff,
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,};

static const BYTE j7table[] = {
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
0xff, 0x00, 0x01, 0xff, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0x09, 0x0a, 0x0b, 0xff, 0x0c,
0x0d, 0x0e, 0x0f, 0x10, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16, 0x17, 0x18, 0x19, 0x1a, 0x1b, 0x1c,
0x1d, 0x1e, 0x1f, 0x20, 0x21, 0x22, 0x23, 0x24, 0x25, 0x26, 0x27, 0x28, 0x29, 0x2a, 0x2b, 0x2c,
0x2d, 0x2e, 0x2f, 0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38, 0x39, 0x3a, 0x3b, 0x3c,
0xff, 0x3d, 0x3e, 0x3f, 0x40, 0x41, 0x42, 0x43, 0x44, 0x45, 0x46, 0x47, 0x48, 0x49, 0x4a, 0x4b,
0x4c, 0x4d, 0x4e, 0x4f, 0x50, 0x51, 0x52, 0x53, 0x54, 0x55, 0x56, 0x57, 0x58, 0x59, 0x5a, 0xff,};
static const int dj7_m[] = {0, 3, 6, 1, 4, 7, 2, 5};

static const BYTE sjntable[] = {
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
0xff, 0x00, 0x01, 0xff, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0x09, 0x0a, 0x0b, 0xff, 0x0c,
0x0d, 0x0e, 0x0f, 0x10, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16, 0x17, 0x18, 0x19, 0x1a, 0x1b, 0x1c,
0x1d, 0x1e, 0x1f, 0x20, 0x21, 0x22, 0x23, 0x24, 0x25, 0x26, 0x27, 0x28, 0x29, 0x2a, 0x2b, 0x2c,
0x2d, 0x2e, 0x2f, 0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38, 0x39, 0x3a, 0x3b, 0x3c,
0xff, 0x3d, 0x3e, 0x3f, 0x40, 0x41, 0x42, 0x43, 0x44, 0x45, 0x46, 0x47, 0x48, 0x49, 0x4a, 0x4b,
0x4c, 0x4d, 0x4e, 0x4f, 0x50, 0x51, 0x52, 0x53, 0x54, 0x55, 0x56, 0x57, 0x58, 0x59, 0x5a, 0xff,
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x5b, 0x5c, 0x5d, 0x5e, 0x5f, 0x60, 0x61,
0x62, 0x63, 0x64, 0x65, 0x66, 0x67, 0x68, 0x69, 0xff, 0x6a, 0x6b, 0x6c, 0x6d, 0x6e, 0x6f, 0x70,
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
0x71, 0x72, 0x73, 0x74, 0x75, 0x76, 0x77, 0x78, 0x79, 0x7a, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,};

static const BYTE sjtable[] = {
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x3e, 0x3f, 0x40, 0x41, 0x42, 0x43, 0x44, 0x45, 0x46,
0x56, 0xa7, 0xa8, 0xa9, 0xaa, 0xab, 0xac, 0xad, 0xae, 0xaf, 0xb0, 0xb1, 0xb2, 0xb3, 0xb4, 0xb5,
0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0x09, 0x0a, 0x0b, 0x0c, 0x0d, 0x0e, 0x0f,
0x10, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16, 0x17, 0x18, 0x19, 0x1a, 0x1b, 0x1c, 0x1d, 0x1e, 0x1f,
0xff, 0x20, 0x21, 0x22, 0x23, 0x24, 0x25, 0x26, 0x27, 0x28, 0x29, 0x2a, 0x2b, 0x2c, 0x2d, 0x2e,
0x2f, 0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38, 0x39, 0x3a, 0x3b, 0x3c, 0x3d, 0xff,
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x47, 0x48, 0x49, 0x4a, 0x4b, 0x4c, 0x4d,
0x4e, 0x4f, 0x50, 0x51, 0x52, 0x53, 0x54, 0x55, 0xff, 0x57, 0x58, 0x59, 0x5a, 0x5b, 0x5c, 0x5d,
0xff, 0x5e, 0x5f, 0x60, 0x61, 0x62, 0x63, 0x64, 0x65, 0x66, 0x67, 0x68, 0x69, 0x6a, 0x6b, 0x6c,
0x6d, 0x6e, 0x6f, 0x70, 0x71, 0x72, 0x73, 0x74, 0x75, 0x76, 0x77, 0x78, 0x79, 0x7a, 0x7b, 0x7c,
0x7d, 0x7e, 0x7f, 0x80, 0x81, 0x82, 0x83, 0x84, 0x85, 0x86, 0x87, 0x88, 0x89, 0x8a, 0x8b, 0x8c,
0x8d, 0x8e, 0x8f, 0x90, 0x91, 0x92, 0x93, 0x94, 0x95, 0x96, 0x97, 0x98, 0x99, 0x9a, 0x9b, 0x9c,
0x9d, 0x9e, 0x9f, 0xa0, 0xa1, 0xa2, 0xa3, 0xa4, 0xa5, 0xa6, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,};

static const BYTE sj2table[] = {
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0x09, 0x0a, 0x0b, 0x0c, 0x0d, 0x0e, 0x0f,
0x10, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16, 0x17, 0x18, 0x19, 0x1a, 0x1b, 0x1c, 0x1d, 0x1e, 0x1f,
0xff, 0x20, 0x21, 0x22, 0x23, 0x24, 0x25, 0x26, 0x27, 0x28, 0x29, 0x2a, 0x2b, 0x2c, 0x2d, 0x2e,
0x2f, 0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38, 0x39, 0x3a, 0x3b, 0x3c, 0x3d, 0xff,
0x3e, 0x3f, 0x40, 0x41, 0x42, 0x43, 0x44, 0x45, 0x46, 0x47, 0x48, 0x49, 0x4a, 0x4b, 0x4c, 0x4d,
0x4e, 0x4f, 0x50, 0x51, 0x52, 0x53, 0x54, 0x55, 0x56, 0x57, 0x58, 0x59, 0x5a, 0x5b, 0x5c, 0x5d,
0xff, 0x5e, 0x5f, 0x60, 0x61, 0x62, 0x63, 0x64, 0x65, 0x66, 0x67, 0x68, 0x69, 0x6a, 0x6b, 0x6c,
0x6d, 0x6e, 0x6f, 0x70, 0x71, 0x72, 0x73, 0x74, 0x75, 0x76, 0x77, 0x78, 0x79, 0x7a, 0x7b, 0x7c,
0x7d, 0x7e, 0x7f, 0x80, 0x81, 0x82, 0x83, 0x84, 0x85, 0x86, 0x87, 0x88, 0x89, 0x8a, 0x8b, 0x8c,
0x8d, 0x8e, 0x8f, 0x90, 0x91, 0x92, 0x93, 0x94, 0x95, 0x96, 0x97, 0x98, 0x99, 0x9a, 0x9b, 0x9c,
0x9d, 0x9e, 0x9f, 0xa0, 0xa1, 0xa2, 0xa3, 0xa4, 0xa5, 0xa6, 0xa7, 0xa8, 0xa9, 0xaa, 0xab, 0xac,
0xad, 0xae, 0xaf, 0xb0, 0xb1, 0xb2, 0xb3, 0xb4, 0xb5, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,};

static int decode_jis8(BYTE* str,int len,BYTE* outbuf)
{
	len=(len>79)?79:len;
	BYTE* start=outbuf;

	outbuf--;
	for( int i=0,j,c; i<len; ++i )
	{
		if( (c=j8table[str[i]])==0xff )
			return 0;
		if( j=(i&7) )
			*outbuf |= c<<(8-j);
		if( j!=7 )
			*++outbuf = c>>j;
	}

	return outbuf-start;
}

static int decode_jis7(BYTE* str,int len,BYTE* outbuf)
{
	len=(len>78)?78:len;
	BYTE* start=outbuf;

	int c,c1,c2,c3;
	if( (c =j7table[str[0]])==0xff )	return 0;
	if( (c1=j7table[str[1]])==0xff )	return 0;
	if( (c2=j7table[str[2]])==0xff )	return 0;
	if( (c3=j7table[str[3]])==0xff )	return 0;
	*outbuf++ = c1<<6 | c;
	*outbuf++ = c2<<4 | c1>> 2;
	*outbuf   = c3<<2 | c2>> 4;

	for( int i=0,k=4,j,d; k<len; ++i )
	{
		if( (c1=j7table[str[k++]])==0xff )	return 0;
		if( (c2=j7table[str[k++]])==0xff )	return 0;

		d = c1*91 + c2;
		if( d>0x3fff )return 0;

		if( (j=dj7_m[i & (8-1)]) != 0)
			*outbuf |= d<<(8-j)&0xff;
		*++outbuf = d>>j;
		if( j<5 )
			*++outbuf = d>>(8+j);
    }

	return outbuf-start;
}

static int decode_njis(BYTE* str,int len,BYTE* outbuf)
{
	len=(len>79)?79:len;
	BYTE* start=outbuf;

	*outbuf = j7table[*str++];

    int c1,m=75,scount=0;
    unsigned d;
	while( m>=0 )
	{
		if( (c1=sjntable[*str++])==0xff)	return 0;
		m--;
		if( c1<91 )
		{
			d = c1 * 123;
			c1 = sjntable[*str++];
			m--;
			d += c1;
			//ins14(d);///
			d &= 0x3fff;
			if(scount)*outbuf |= (d << (8-scount)) & 0xff;
			*++outbuf = d >> scount;
			if(scount<6)*++outbuf = d >> (8+scount);
			scount = (scount + 2) & 7;
			//////////////
			if( c1>=91)
			{
				d = sj2table[*str++];
				m--;
				if( scount )
					*outbuf |= (d << (8-scount)) & 0xff;
				if( scount<7 )
					*++outbuf = d >> scount;
				scount = (scount+1)&7;
			}
		}
		else
		{
		    c1 -= 91;
		    d = c1 * 182 + 11193;
		    c1 = sj2table[*str++];
			m--;
			d += c1;
			//ins14(d);///
			d &= 0x3fff;
			if(scount)*outbuf |= (d << (8-scount)) & 0xff;
			*++outbuf = d >> scount;
			if(scount<6)*++outbuf = d >> (8+scount);
			scount = (scount + 2) & 7;
			//////////////
		}
	}
    if( m<0 )
	{
		c1 = j7table[*str++];
		if( m==-2 )
		{
		    d = c1 & 0x3f;
		    if(scount)
				*outbuf |= (d << (8-scount)) & 0xff;
			outbuf++;
		    if(scount<6)
				*outbuf = d >> scount;
		}
		else if( m==-1 )
		{
			d = c1 * 91;
			d = (d + j7table[*str]) & 0x1fff;
			//ins14(d);///
			d &= 0x3fff;
			if(scount)*outbuf |= (d << (8-scount)) & 0xff;
			*++outbuf = d >> scount;
			if(scount<6)*++outbuf = d >> (8+scount);
			scount = (scount + 2) & 7;
			//////////////
		}
    }

	return outbuf-start;
}

static int decode_sjis(BYTE* str,int len,BYTE* outbuf)
{
	len=(len>78)?78:len;
	BYTE* start=outbuf;

	BYTE c;
	if( (c=j8table[*str])==0xff )return 0;
	*outbuf = c;

	// 15bit decoding
	WORD i,k,sjdf,j,d;
	for( i=1,k=1,sjdf=0,j,d; k<len-1; ++i )
	{
		// 1st char
		c = str[k++];
		if( sjdf==0 )
		{
			if( (c>=0x80 && c<=0x9f) || (c>=0xe0 && c<=0xe9) ) sjdf=1;
			c = sjtable[c];
		}
		else
		{
			c = sj2table[c];
			sjdf = 0;
		}
		if( c==0xff )return 0;
		d = c * 182;

		// 2nd char
		c = str[k++];
		if( sjdf==0 )
		{
			if( (c>=0x80 && c<=0x9f) || (c>=0xe0 && c<=0xe9) ) sjdf=1;
			c = sjtable[c];
		}
		else
		{
			c = sj2table[c];
			sjdf = 0;
		}
		if( c==0xff )return 0;
		if( (d+=c)>0x7fff )return 0;

		// store to LINE
		if( (j=(i&(8-1)))!=0 )*outbuf |= d << (8 - j) & 0xff;
		*++outbuf = d >> j;
		if( j<7 )*++outbuf = d >> (8 + j);
	}

	// the last char has 7bit data
	c = str[k++];
	if( sjdf==0 )
	{
		if( c>=0xc9 && c<=0xdf )c = c + (0x100 - 0x40) & 0xff;
		c = sjtable[c];
	}
	else
		c = sj2table[c];
	if( c==0xff )return 0;
	*outbuf++ |= c << (8 - i & (8 - 1)) & 0xff;

	return outbuf-start;
}
